/*
 * ProcessUI.java
 *
 * Created on 23. Februar 2004, 19:57
 */

package jrat.client.shell;

import java.awt.event.*;
import java.rmi.RemoteException;
import java.awt.*;
import javax.swing.*;
import jrat.server.shell.*;
import java.util.*;
import jrat.client.*;

/**
 *
 * @author  tobi
 */
public class ProcessUI extends ShellUI {
    
    
    /** Creates new form ShellFuncUI */
    public ProcessUI(ShellServerI server) {
        super(server);
        
        init();
        
        
    }
    
    public void init() {
        initComponents();
        initButtonListeners(this);                
       
    }
    
    
    
    private void initButtonListeners(Container comp) {
        Component[] children = comp.getComponents();
        for (int i = 0; i < children.length; i++) {
            if (children[i] instanceof JButton) {
                children[i].addMouseListener(new ButtonMouseListener());
            } else if (children[i] instanceof Container) {
                comp = (Container)children[i];
                initButtonListeners(comp);
            }
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        contrPan = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        getBtn = new javax.swing.JButton();
        killBtn = new javax.swing.JButton();
        centerPan = new javax.swing.JPanel();
        centerTabPan = new javax.swing.JTabbedPane();
        processPan = new javax.swing.JPanel();
        pscrollPan = new javax.swing.JScrollPane();
        plist = new javax.swing.JList();
        servicePan = new javax.swing.JPanel();
        sscrollPan = new javax.swing.JScrollPane();
        slist = new javax.swing.JList();

        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.GridBagLayout());

        getBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jrat/client/gfx/ok.gif")));
        getBtn.setText("receive");
        getBtn.setToolTipText("receive the currently running processes (including services)");
        getBtn.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        getBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(getBtn, gridBagConstraints);

        killBtn.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jrat/client/gfx/stop.gif")));
        killBtn.setText("kill");
        killBtn.setToolTipText("try to kill the selected process / service");
        killBtn.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        killBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                killBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel1.add(killBtn, gridBagConstraints);

        contrPan.add(jPanel1);

        add(contrPan, java.awt.BorderLayout.WEST);

        centerPan.setLayout(new java.awt.BorderLayout());

        centerTabPan.setOpaque(true);
        processPan.setLayout(new java.awt.BorderLayout());

        pscrollPan.setViewportView(plist);

        processPan.add(pscrollPan, java.awt.BorderLayout.CENTER);

        centerTabPan.addTab("processes", processPan);

        servicePan.setLayout(new java.awt.BorderLayout());

        sscrollPan.setViewportView(slist);

        servicePan.add(sscrollPan, java.awt.BorderLayout.CENTER);

        centerTabPan.addTab("services", servicePan);

        centerPan.add(centerTabPan, java.awt.BorderLayout.CENTER);

        add(centerPan, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    private void killBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_killBtnActionPerformed
        switch (os) {
            case WIN2K:
                if (centerTabPan.getSelectedComponent() == servicePan) { // Services-Ansicht aktiv
                    Process service = (Process) slist.getSelectedValue();
                    if (service != null && !service.toString().equals("")) {
                        kill(service.toString());
                    }
                } else {                                                 // Prozess-Ansicht aktiv
                    ;
                }
                break;
                
            case LINUX:
                if (centerTabPan.getSelectedComponent() == servicePan) { // Services-Ansicht aktiv
                   ;
                } else {                                                 // Prozess-Ansicht aktiv
                    Process service = (Process) plist.getSelectedValue();
                    if (service != null && !service.toString().equals("")) {
                        kill(service.pid);
                    }
                }
                break;
                
        }
    }//GEN-LAST:event_killBtnActionPerformed
    
    public void kill(String proc) {
        MainUI.setStatus("try to kill "+proc+"..");
        shellTxt.setText("");
        String result = null;
        
        switch (os) {
            case WIN2K:
                result = executeToString("net stop \""+proc+"\"");
                break;
            case LINUX:
                result = executeToString("kill \""+proc+"\"");
                break;
            default:
                throw new IllegalArgumentException("unknown OS");
        }
        
        JOptionPane.showMessageDialog(this, result);
        receive();
    }
    
    /**
     * fhrt ein Kommando aus
     * @param cmd
     */
    // berschrieben
    public String executeToString(String cmd) {
        try {
            return control.getServer().exec(cmd, true);
        } catch (Exception e1) {
            jrat.client.MessageDialog.message(this, "not connected!");
            e1.printStackTrace();
        }
        return null;
    }
    
    private void getBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getBtnActionPerformed
        resolveOS();
        receive();
    }//GEN-LAST:event_getBtnActionPerformed
    
    public void receive() {      
        MainUI.setStatus("receiving processes");   
        receiveServices();      
        receiveProcesses();         
        MainUI.setStatus("processes updated");        
    }
    
    public void receiveProcesses() {       
        Vector data = new Vector();
        
        /** alle Dienste ermitteln */
        switch (os) {
            case LINUX:                
                
                shellTxt.setText("");
                execute("ps x");
                StringTokenizer tok = new StringTokenizer(shellTxt.getText(), "\n");
                
                while (tok.hasMoreTokens()) {
                    String s = tok.nextToken();
                    
                    
                    try {
                        System.out.println("|"+s.substring(1,5)+"|");
                        int pid = Integer.parseInt(s.substring(1,5));
                        
                        data.add(new Process(""+pid, s));
                    } catch (Exception e) {
                        // das war kein Prozess !
                        // etwas unsaubere Lsung aber egal
                        System.out.println("false: ");
                        continue;
                    }
                    
                }
                
                plist.setListData(data);
                plist.updateUI();
                break;
               
            case WIN2K:
                centerTabPan.setSelectedComponent(servicePan); // Services whlen
               
                shellTxt.setText("");
                data.add("not yet implemented for this os");
                data.add("take a look at 'services' to control at least them");
                plist.setListData(data);
                plist.updateUI();
                break;
                
            default:
                throw new IllegalArgumentException("unknown OS");
        }
        
        
    }
    
    public void receiveServices() {
        Vector data = new Vector();
        
        /** alle Prozesse ermitteln */
        switch (os) {
            case WIN2K:
                shellTxt.setText("");
                execute("net start");
                StringTokenizer tok = new StringTokenizer(shellTxt.getText(), "\n");               
                while (tok.hasMoreTokens()) {
                    String s = tok.nextToken();
            /* Windows cmd stellt rckt Dienste in der Konsole
             * um 2 Stellen ein. Wie ist das woanders? */
                    if (s.charAt(0) == ' ') {
                        data.add(new Process(s.trim(), s.trim()));
                    }
                }
                slist.setListData(data);
                slist.updateUI();
                break;
            case LINUX:
                centerTabPan.setSelectedComponent(processPan); // processes whlen
                shellTxt.setText("");
                data.add("not yet implemented for this os");
                data.add("take a look at 'processes' to view all of them");
                slist.setListData(data);
                slist.updateUI();             
                break;
        }
        // ...
    }
    
   
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel centerPan;
    private javax.swing.JTabbedPane centerTabPan;
    private javax.swing.JPanel contrPan;
    private javax.swing.JButton getBtn;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton killBtn;
    private javax.swing.JList plist;
    private javax.swing.JPanel processPan;
    private javax.swing.JScrollPane pscrollPan;
    private javax.swing.JPanel servicePan;
    private javax.swing.JList slist;
    private javax.swing.JScrollPane sscrollPan;
    // End of variables declaration//GEN-END:variables
    
    private static class Process {
        public String pid;
        public String name;
        
        public Process(String pid, String name) {
            this.pid = pid;
            this.name = name;
        }
        
        public String toString() {
            return this.name;
        }
    }
    
}
