/*
 * ShellFuncUI.java
 *
 * Created on 22. Februar 2004, 19:10
 */

package jrat.client.shell;

import java.awt.event.*;
import java.rmi.RemoteException;
import java.awt.*;
import javax.swing.*;
import jrat.server.shell.*;
import jrat.client.*;

/**
 *
 * @author  tobi
 */
public class ShellFuncUI extends jrat.client.shell.ShellUI {
    private JFrame frame;
    
    /** Creates new form ShellFuncUI */
    public ShellFuncUI(ShellServerI server) {
        super(server);
        initComponents();
        init();
    }
    
    public void init() {
      /*  frame = new JFrame();
        frame.setTitle("tos RemoteShell");
        frame.getContentPane().setLayout(new BorderLayout());
        frame.getContentPane().add(this.shellScroll, BorderLayout.CENTER);
        frame.setSize(500,300);
       */
        initButtonListeners(this);
        shellPan.add(this.shellScroll, BorderLayout.CENTER);
    }
    
    private void initButtonListeners(Container comp) {
        Component[] children = comp.getComponents();
        for (int i = 0; i < children.length; i++) {
            if (children[i] instanceof JButton) {
               children[i].addMouseListener(new ButtonMouseListener());             
            } else if (children[i] instanceof Container) {
                comp = (Container)children[i];
                initButtonListeners(comp);            
            }
        }       
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        FunctionsPan = new javax.swing.JPanel();
        netstatPan = new javax.swing.JPanel();
        netstatrBtn = new javax.swing.JButton();
        netstatBtn = new javax.swing.JButton();
        netstataBtn = new javax.swing.JButton();
        netstateBtn = new javax.swing.JButton();
        miscnetPan = new javax.swing.JPanel();
        ipconfBtn = new javax.swing.JButton();
        arpBtn = new javax.swing.JButton();
        hostnameBtn = new javax.swing.JButton();
        memBtn = new javax.swing.JButton();
        modeBtn = new javax.swing.JButton();
        netshareBtn = new javax.swing.JButton();
        nslookupBtn = new javax.swing.JButton();
        ftypeBtn = new javax.swing.JButton();
        procPan = new javax.swing.JPanel();
        servBtn = new javax.swing.JButton();
        shellPan = new javax.swing.JPanel();

        setLayout(new java.awt.BorderLayout());

        FunctionsPan.setLayout(new java.awt.GridBagLayout());

        FunctionsPan.setBorder(new javax.swing.border.TitledBorder("Functions"));
        netstatPan.setLayout(new java.awt.GridBagLayout());

        netstatPan.setBorder(new javax.swing.border.TitledBorder("netstat"));
        netstatrBtn.setText("routing");
        netstatrBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                netstatrBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        netstatPan.add(netstatrBtn, gridBagConstraints);

        netstatBtn.setText("numeric");
        netstatBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                netstatBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        netstatPan.add(netstatBtn, gridBagConstraints);

        netstataBtn.setText("status");
        netstataBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                netstataBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        netstatPan.add(netstataBtn, gridBagConstraints);

        netstateBtn.setText("ethernet");
        netstateBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                netstateBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        netstatPan.add(netstateBtn, gridBagConstraints);

        FunctionsPan.add(netstatPan, new java.awt.GridBagConstraints());

        miscnetPan.setLayout(new java.awt.GridBagLayout());

        miscnetPan.setBorder(new javax.swing.border.TitledBorder("mics"));
        ipconfBtn.setText("ipconf");
        ipconfBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ipconfBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(ipconfBtn, gridBagConstraints);

        arpBtn.setText("arp");
        arpBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                arpBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(arpBtn, gridBagConstraints);

        hostnameBtn.setText("hostname");
        hostnameBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hostnameBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(hostnameBtn, gridBagConstraints);

        memBtn.setText("mem");
        memBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                memBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(memBtn, gridBagConstraints);

        modeBtn.setText("mode");
        modeBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                modeBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(modeBtn, gridBagConstraints);

        netshareBtn.setText("shares");
        netshareBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                netshareBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(netshareBtn, gridBagConstraints);

        nslookupBtn.setText("nslookup");
        nslookupBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nslookupBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(nslookupBtn, gridBagConstraints);

        ftypeBtn.setText("ftype");
        ftypeBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ftypeBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        miscnetPan.add(ftypeBtn, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        FunctionsPan.add(miscnetPan, gridBagConstraints);

        procPan.setLayout(new java.awt.GridBagLayout());

        procPan.setBorder(new javax.swing.border.TitledBorder("process"));
        servBtn.setText("services");
        servBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                servBtnActionPerformed(evt);
            }
        });

        procPan.add(servBtn, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        FunctionsPan.add(procPan, gridBagConstraints);

        add(FunctionsPan, java.awt.BorderLayout.NORTH);

        shellPan.setLayout(new java.awt.BorderLayout());

        add(shellPan, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    /**
     * fhrt ein Kommando aus
     * @param cmd
     */
    // berschrieben
    public void execute(String cmd) {
        try {
            String res = control.getServer().exec(cmd, true);
            shellTxt.setText(
            shellTxt.getText() + "\n\n" + res + "\n");
            control.addHistory(cmd);
        } catch (Exception e1) {
            jrat.client.MessageDialog.message(this, "not connected!");
            e1.printStackTrace();
        }
    }
    
    private void ftypeBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ftypeBtnActionPerformed
       shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("ftype");       
               break;
            case LINUX:
               message_notImpl("ftype");
               break;
        }
    }//GEN-LAST:event_ftypeBtnActionPerformed
    
    private void nslookupBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nslookupBtnActionPerformed
       shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("nslookup");       
               break;
            case LINUX:
               ;
               break;
        }
    }//GEN-LAST:event_nslookupBtnActionPerformed
    
    private void netshareBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_netshareBtnActionPerformed
       shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("net share");       
               break;
            case LINUX:
               message_notImpl("net share");
               break;
        }
    }//GEN-LAST:event_netshareBtnActionPerformed
    
    private void modeBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_modeBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("mode");       
               break;
            case LINUX:
               message_notImpl("mode");
               break;
        }
    }//GEN-LAST:event_modeBtnActionPerformed
    
    private void memBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_memBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("mem");       
               break;
            case LINUX:
               execute("df");
               break;
        }
    }//GEN-LAST:event_memBtnActionPerformed
    
    private void hostnameBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hostnameBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("hostname");       
               break;
            case LINUX:
               execute("hostname"); 
               break;
        }
    }//GEN-LAST:event_hostnameBtnActionPerformed
    
    private void servBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_servBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("net start");       
               break;
            case LINUX:
               execute("netstat -apn | grep LISTEM"); 
               break;
        }
    }//GEN-LAST:event_servBtnActionPerformed
    
    private void netstateBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_netstateBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("netstat -e");       
               break;
            case LINUX:
               execute("netstat -s");  
               break;
        }
    }//GEN-LAST:event_netstateBtnActionPerformed
    
    private void netstataBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_netstataBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("netstat -a");       
               break;
            case LINUX:
               execute("netstat -a"); 
               break;
        }
    }//GEN-LAST:event_netstataBtnActionPerformed
    
    private void netstatrBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_netstatrBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("netstat -r");       
               break;
            case LINUX:
               execute("netstat -r"); 
               break;
        }
    }//GEN-LAST:event_netstatrBtnActionPerformed
    
    private void ipconfBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ipconfBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("ipconfig");       
               break;
            case LINUX:
               execute("ifconfig"); 
               break;
        }
    }//GEN-LAST:event_ipconfBtnActionPerformed
    
    private void arpBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_arpBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("arp -a");       
               break;
            case LINUX:
               execute("arp -a"); 
               break;
        }
    }//GEN-LAST:event_arpBtnActionPerformed
    
    private void netstatBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_netstatBtnActionPerformed
        shellTxt.setText("");
       if (os < 0)
            resolveOS();
       
        switch (os) {
            case WIN2K:
               execute("netstat -n");       
               break;
            case LINUX:
               execute("netstat -n");  
               break;
        }
    }//GEN-LAST:event_netstatBtnActionPerformed
    
    private void message_notImpl(String command) {
        shellTxt.setText("'"+command+"' is not implemented for this open system");
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel FunctionsPan;
    private javax.swing.JButton arpBtn;
    private javax.swing.JButton ftypeBtn;
    private javax.swing.JButton hostnameBtn;
    private javax.swing.JButton ipconfBtn;
    private javax.swing.JButton memBtn;
    private javax.swing.JPanel miscnetPan;
    private javax.swing.JButton modeBtn;
    private javax.swing.JButton netshareBtn;
    private javax.swing.JButton netstatBtn;
    private javax.swing.JPanel netstatPan;
    private javax.swing.JButton netstataBtn;
    private javax.swing.JButton netstateBtn;
    private javax.swing.JButton netstatrBtn;
    private javax.swing.JButton nslookupBtn;
    private javax.swing.JPanel procPan;
    private javax.swing.JButton servBtn;
    private javax.swing.JPanel shellPan;
    // End of variables declaration//GEN-END:variables
    
}
