/*
 * ShellUI.java
 *
 * Created on 12. Januar 2004, 21:03
 */
package jrat.client.shell;

import java.awt.event.*;
import java.rmi.RemoteException;
import jrat.server.shell.*;

/**
 * Oberflche fr den Shellemulator
 * @author  tobi
 */
public class ShellUI extends javax.swing.JPanel {
    protected final static int WIN2K = 1;
    protected final static int WIN95 = 2;
    protected final static int LINUX = 3;
    protected int os = -1;
    
    ShellC control;
    protected String shellSign = "$: ";
    
    /** Creates new form ShellUI */
    public ShellUI(ShellServerI server) {
        this.control = new ShellC(server);
        initComponents();
        shellTxt.setText(shellSign);
        shellTxt.addKeyListener(new ShellKeyListener());
        shellTxt.requestFocus();
    }
    
    public void setServer(ShellServerI s) {
        control.setServer(s);
    }
    
    
    
    /**
     * fhrt ein Kommando aus
     * @param cmd
     */
    public void execute(String cmd) {
        try {
            String res = control.getServer().exec(cmd, true);
            shellTxt.setText(
            shellTxt.getText() + "\n\n" + res + "\n" + shellSign);
            control.addHistory(cmd);
        } catch (Exception e1) {
            jrat.client.MessageDialog.message(this, "not connected!");
            e1.printStackTrace();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        centerPan1 = new javax.swing.JPanel();
        shellScroll = new javax.swing.JScrollPane();
        shellTxt = new javax.swing.JTextPane();

        setLayout(new java.awt.BorderLayout());

        centerPan1.setLayout(new java.awt.BorderLayout());

        centerPan1.setBorder(new javax.swing.border.TitledBorder("Shell"));
        shellScroll.setViewportView(shellTxt);

        centerPan1.add(shellScroll, java.awt.BorderLayout.CENTER);

        add(centerPan1, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents
    
    public void resolveOS() {
        String osName = null;
        try {
            osName = control.getServer().getOS();
        } catch (Exception e) {
            jrat.client.MessageDialog.message(this, "not connected!");
            e.printStackTrace();
        }
        if (osName.equals("Windows NT") || osName.equals("Windows XP")) {
            this.os = WIN2K;
        } else if (osName.equals("Windows 95")) {
            this.os = WIN95;
        } else if (osName.equals("Linux")) {
            this.os = LINUX;
        } else {
            System.out.println("OS nicht spezifiziert: " + osName);
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel centerPan1;
    protected javax.swing.JScrollPane shellScroll;
    protected javax.swing.JTextPane shellTxt;
    // End of variables declaration//GEN-END:variables
    
    /**
     * Keylistener
     * @author tobi
     */
    class ShellKeyListener extends KeyAdapter {
        public void keyPressed(KeyEvent evt) {
            if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
                String txt = shellTxt.getText();
                String cmd = txt.substring(txt.lastIndexOf(shellSign) + 3);
                System.out.println("execute: " + cmd);
                execute(cmd);
                evt.consume();
            } else if (evt.getKeyCode() == KeyEvent.VK_UP) {
                String txt = shellTxt.getText();
                shellTxt.setText(
                txt.substring(0, txt.lastIndexOf(shellSign) + 3)
                + control.getHistory());
                evt.consume();
            }
        }
    }
}
