/*
 * Created on 16.01.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package tos.inet;

import java.io.*;
import java.util.*;

/**
 * @author tobi
 */
public class InternetConnection implements Runnable {
	private long waitForPing = 15000;
	private String host = "www.google.de";
	private StringBuffer buff = new StringBuffer();

	private final static int CONNECTED = 1;

	private final static int NOT_CONNECTED = 2;	
	
	private final static int UNKNOWN = 3;
	
	private int status = UNKNOWN;

	private Vector olisteners = new Vector();

	public static void main(String[] args) {
		new InternetConnection(15000);
	}

	public InternetConnection(long waitForPing) {
		this.waitForPing = waitForPing;
		Thread th = new Thread(this);
		th.start();
	}

	public void addOnlineListener(OnlineListener listener) {
		olisteners.add(listener);
	}

	public void run() {
		while (true) {
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			boolean online = online();			
		}
	}
	public boolean online() {
		String res = ping().toUpperCase();
		if (res.indexOf("TTL") > 0) {
			if (status != CONNECTED) {
				status = CONNECTED;
				notify(new OnlineEvent(this, OnlineEvent.CONNECTED));
			}
			
			return true;
			
		} else {
			if (status != NOT_CONNECTED) {			
			   status = NOT_CONNECTED;
			   notify(new OnlineEvent(this, OnlineEvent.NOT_CONNECTED));			   
			}
			return false;
		}
	}

	/**
		 * Sendet die Online-Notify an alle Listener
		 * @param e
		 */
	protected synchronized void notify(OnlineEvent e) {
		for (int i = 0; i < olisteners.size(); i++)
			 ((OnlineListener) olisteners.elementAt(i)).connectionChanged(e);

	}

	public String ping() {
		try {

			// OS ermitteln
			String osName = System.getProperty("os.name");
			String[] cmd = new String[3];
			if (osName.equals("Windows NT") || osName.equals("Windows XP")) {
				cmd[0] = "cmd.exe";
				cmd[1] = "/C";
				cmd[2] = "ping  -n 1 " + host;
			} else if (osName.equals("Windows 95")) {
				cmd[0] = "command.com";
				cmd[1] = "/C";
				cmd[2] = "ping  -n 1 " + host;
			} else if (osName.equals("Linux")) {
				cmd[0] = "/bin/sh";
				cmd[1] = "-c";
				cmd[2] = "ping -n 1 " + host;
			} else {
				cmd[0] = "";
				cmd[1] = "";
				cmd[2] = "ping -n 1 " + host;
				System.out.println("OS nicht spezifiziert: " + osName);
			}

			Runtime rt = Runtime.getRuntime();
			Process proc = rt.exec(cmd);

			// any error message?
			StreamGobbler errorGobbler =
				new StreamGobbler(proc.getErrorStream(), "ERROR");

			// any output?
			StreamGobbler outputGobbler =
				new StreamGobbler(proc.getInputStream(), "OUTPUT");

			// kick them off
			errorGobbler.start();
			outputGobbler.start();

			// eine Zeitlang auf den Output warten			
			outputGobbler.join(waitForPing);
			errorGobbler.join(waitForPing);

			String s = buff.toString();
			buff = new StringBuffer();

			return s;

		} catch (Throwable t) {
			t.printStackTrace();
			return null;
		}
	}

	/**
		 * Absorbiert die Eingabestrme (Resultate der Befehle
		 * in der Konsole)		
		 */
	class StreamGobbler extends Thread {
		InputStream is;
		String type;

		StreamGobbler(InputStream is, String type) {
			this.is = is;
			this.type = type;
		}

		public void run() {
			try {
				InputStreamReader isr = new InputStreamReader(is);
				BufferedReader br = new BufferedReader(isr);
				String line = null;
				while ((line = br.readLine()) != null)
					buff.append(line + "\n");
			} catch (IOException ioe) {
				ioe.printStackTrace();
			}
		}
	}

}
